#include "dt9806.h"
#include "ui_dt9806.h"

//header from the C++ library we need to output the error code, WIRD VIELLEICHT NICHT BENOETIGT
#include <iostream>
//header from the DT DataAcq SDK.
#include <OLERRORS.H>

DT9806::DT9806(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::DT9806)
{
    ui->setupUi(this);
}

DT9806::~DT9806()
{
    showError(olDaReleaseDASS(hdass));
    showError(olDaTerminate(hdrvr));
    delete ui;
}

//void showError(ECODE e);

DT9806::DT9806(char *name)
{
    showError(olDaInitialize(name, &hdrvr));
}

void DT9806::setAnalogInputSubsystem()
{
    showError(olDaGetDASS(hdrvr, OLSS_AD, 0, &hdass));
    showError(olDaSetDataFlow(hdass, OL_DF_SINGLEVALUE));
    showError(olDaConfig(hdass));
}

long DT9806::getValue()
{
    long value;
    showError(olDaGetSingleValue(hdass, &value, 0, 1.0));
    return value;
}

double DT9806::getVolt(long value)
{
    double volts, minRangeVolts, maxRangeVolts;
    unsigned int bitResolution, encoding;

    showError(olDaGetRange(hdass, &maxRangeVolts, &minRangeVolts));
    showError(olDaGetEncoding(hdass, &encoding));
    showError(olDaGetResolution(hdass, &bitResolution));
    showError(olDaCodeToVolts(minRangeVolts, maxRangeVolts, 1.0, bitResolution, encoding, value, &volts));

    return volts;
}

void DT9806::showError(ECODE e)
{
    if(e != OLNOERROR)
    {
        char temp[80];
        olDaGetErrorString(e, temp, 80);
        exit(0);
    }
}
