#ifndef DT9806_H
#define DT9806_H

#include <QMainWindow>
#include <windows.h>

//headers from the DT DataAcq SDK
#include <OLDAAPI.H>
#include <OLDADEFS.H>

namespace Ui {
class DT9806;
}

class DT9806 : public QMainWindow
{
    Q_OBJECT

public:
    explicit DT9806(QWidget *parent = 0);
    //~DT9806();
    //constructor. initializes the DT device given by the board name
    DT9806(char* name);
    //destructor. disposes the DT device. the destructor is called automatically at the end of the application.
    //so use it carfully or the error "Invalid subsystem handle" will occure.
    ~DT9806();
    //sets a handle to the analog input subsystem and configures it.
    void setAnalogInputSubsystem();
    //returns the voltage value measured on channel 0, gain 1.0
    long getValue();
    //converts the value to volt and returns the result
    double getVolt(long value);

    void showError(ECODE e);

private:
    Ui::DT9806 *ui;
    //driver handle
    HDEV hdrvr;
    //subsystem handle
    HDASS hdass;
    //board error status
    ECODE status;
};

#endif // DT9806_H
